Loading...
Searching...
No Matches
Ogre::StaticGeometry::GeometryBucket Class Reference

A GeometryBucket is a the lowest level bucket where geometry with the same vertex & index format is stored. More...

`#include <OgreStaticGeometry.h>`

Inheritance diagram for Ogre::StaticGeometry::GeometryBucket:
[legend]

## Public Member Functions

| GeometryBucket (MaterialBucket *parent, const VertexData *vData, const IndexData *iData)
virtual | ~GeometryBucket ()
bool | assign (QueuedGeometry *qsm)
| Try to assign geometry to this bucket.
void | build (bool stencilShadows)
| Build.
bool | getCastsShadows (void) const override
| Method which reports whether this renderable would normally cast a shadow.
const IndexData * | getIndexData (void) const
| Get the index data for this geometry.
const LightList & | getLights (void) const override
| Gets a list of lights, ordered relative to how close they are to this renderable.
const MaterialPtr & | getMaterial (void) const override
| Retrieves a weak reference to the material this renderable object uses.
MaterialBucket * | getParent (void)
void | getRenderOperation (RenderOperation &op) override
| Gets the render operation required to send this object to the frame buffer.
Real | getSquaredViewDepth (const Camera *cam) const override
| Returns the squared distance between the camera and this renderable.
Technique * | getTechnique (void) const override
| Retrieves a pointer to the Material Technique this renderable object uses.
const VertexData * | getVertexData (void) const
| Get the vertex data for this geometry.
void | getWorldTransforms (Matrix4 *xform) const override
| Gets the world transform matrix / matrices for this renderable object.
Public Member Functions inherited from Ogre::Renderable
| Renderable ()
virtual | ~Renderable ()
| Virtual destructor needed as class has virtual methods.
uint16 | _getMaterialLodIndex () const
virtual void | _updateCustomGpuParameter (const GpuProgramParameters::AutoConstantEntry &constantEntry, GpuProgramParameters *params) const
| Update a custom GpuProgramParameters constant which is derived from information only this Renderable knows.
const Vector4f & | getCustomParameter (size_t index) const
| Gets the custom value associated with this Renderable at the given index.
virtual uint16 | getNumWorldTransforms (void) const
| Returns the number of world transform matrices this renderable requires.
bool | getPolygonModeOverrideable (void) const
| Gets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.
bool | getUseIdentityProjection (void) const
| Returns whether or not to use an 'identity' projection.
bool | getUseIdentityView (void) const
| Returns whether or not to use an 'identity' view.
const Any & | getUserAny (void) const
UserObjectBindings & | getUserObjectBindings ()
| Class that provides convenient interface to establish a linkage between custom user application objects and Ogre core classes.
const UserObjectBindings & | getUserObjectBindings () const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
bool | hasCustomParameter (size_t index) const
| Checks whether a custom value is associated with this Renderable at the given index.
virtual void | postRender (SceneManager *sm, RenderSystem *rsys)
| Called immediately after the Renderable has been rendered.
virtual bool | preRender (SceneManager *sm, RenderSystem *rsys)
| Called just prior to the Renderable being rendered.
void | removeCustomParameter (size_t index)
| Removes a custom value which is associated with this Renderable at the given index.
void | setCustomParameter (size_t index, const Vector4f &value)
| Sets a custom parameter for this Renderable, which may be used to drive calculations for this specific Renderable, like GPU program parameters.
void | setPolygonModeOverrideable (bool override)
| Sets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.
void | setUseIdentityProjection (bool useIdentityProjection)
| Sets whether or not to use an 'identity' projection.
void | setUseIdentityView (bool useIdentityView)
| Sets whether or not to use an 'identity' view.
void | setUserAny (const Any &anything)

## Additional Inherited Members

Public Types inherited from Ogre::Renderable
enum | { DEFAULT_PRIORITY = 100 }

## Detailed Description

A GeometryBucket is a the lowest level bucket where geometry with the same vertex & index format is stored.

It also acts as the renderable.

## Constructor & Destructor Documentation

## GeometryBucket()

Ogre::StaticGeometry::GeometryBucket::GeometryBucket | ( | MaterialBucket * | parent,
|  | const VertexData * | vData,
|  | const IndexData * | iData )

Referenced by operator<<.

## ~GeometryBucket()

virtual Ogre::StaticGeometry::GeometryBucket::~GeometryBucket | ( |  | ) |

virtual

## Member Function Documentation

## getParent()

MaterialBucket * Ogre::StaticGeometry::GeometryBucket::getParent | ( | void |  | ) |

inline

## getVertexData()

const VertexData * Ogre::StaticGeometry::GeometryBucket::getVertexData | ( | void |  | ) | const

inline

Get the vertex data for this geometry.

## getIndexData()

const IndexData * Ogre::StaticGeometry::GeometryBucket::getIndexData | ( | void |  | ) | const

inline

Get the index data for this geometry.

## getMaterial()

const MaterialPtr & Ogre::StaticGeometry::GeometryBucket::getMaterial | ( | void |  | ) | const

override virtual

Retrieves a weak reference to the material this renderable object uses.

Note that the Renderable also has the option to override the getTechnique method to specify a particular Technique to use instead of the best one available.

Implements Ogre::Renderable.

## getTechnique()

Technique * Ogre::StaticGeometry::GeometryBucket::getTechnique | ( | void |  | ) | const

override virtual

Retrieves a pointer to the Material Technique this renderable object uses.

This is to allow Renderables to use a chosen Technique if they wish, otherwise they will use the best Technique available for the Material they are using.

Reimplemented from Ogre::Renderable.

## getRenderOperation()

void Ogre::StaticGeometry::GeometryBucket::getRenderOperation | ( | RenderOperation & | op | ) |

override virtual

Gets the render operation required to send this object to the frame buffer.

Implements Ogre::Renderable.

## getWorldTransforms()

void Ogre::StaticGeometry::GeometryBucket::getWorldTransforms | ( | Matrix4 * | xform | ) | const

override virtual

Gets the world transform matrix / matrices for this renderable object.

If the object has any derived transforms, these are expected to be up to date as long as all the SceneNode structures have been updated before this is called.

Note
  Internal Ogre never supports non-affine matrix for world transform matrix/matrices, the behavior is undefined if returns non-affine matrix here.

This method will populate transform with 1 matrix if it does not use GPU vertex blending. If it does use GPU vertex blending it will fill the passed in pointer with an array of matrices, the length being the value returned from getNumWorldTransforms.

Note
  If MeshManager::getBonesUseObjectSpace() is true, the first matrix must contain the world transform of the object, and the rest of the matrices must contain the bone transforms in object space.

Implements Ogre::Renderable.

## getSquaredViewDepth()

Real Ogre::StaticGeometry::GeometryBucket::getSquaredViewDepth | ( | const Camera * | cam | ) | const

override virtual

Returns the squared distance between the camera and this renderable.

Used to sort transparent objects. Squared distance is used to avoid having to perform a square root on the result.

Implements Ogre::Renderable.

## getLights()

const LightList & Ogre::StaticGeometry::GeometryBucket::getLights | ( | void |  | ) | const

override virtual

Gets a list of lights, ordered relative to how close they are to this renderable.

Directional lights, which have no position, will always be first on this list.

Implements Ogre::Renderable.

## getCastsShadows()

bool Ogre::StaticGeometry::GeometryBucket::getCastsShadows | ( | void |  | ) | const

override virtual

Method which reports whether this renderable would normally cast a shadow.

Subclasses should override this if they could have been used to generate a shadow.

Reimplemented from Ogre::Renderable.

## assign()

bool Ogre::StaticGeometry::GeometryBucket::assign | ( | QueuedGeometry * | qsm | ) |

Try to assign geometry to this bucket.

Returns
  false if there is no room left in this bucket

## build()

void Ogre::StaticGeometry::GeometryBucket::build | ( | bool | stencilShadows | ) |

Build.

The documentation for this class was generated from the following file:

- OgreStaticGeometry.h